// constant class -*- c++ -*-

#include "Constant.h"
#include "Value.h"

Constant::Constant (class Value* value) :
  Expression ()
#ifndef EXPR_CACHE
  ,myValue (value)
#endif // EXPR_CACHE
{
#ifdef EXPR_CACHE
  Expression::myValue = value;
#endif // EXPR_CACHE
  assert (myValue && myValue->getType ());
  Expression::setType (myValue->getType ());
}

Constant::~Constant ()
{
#ifndef EXPR_CACHE
  delete myValue;
#endif // EXPR_CACHE
}

bool
Constant::operator== (const class Constant& other) const
{
  if (getValue ()->getKind () != other.getValue ()->getKind ())
    return false;
  return *getValue () == *other.getValue ();
}

bool
Constant::operator< (const class Constant& other) const
{
  if (getValue ()->getKind () < other.getValue ()->getKind ())
    return true;
  if (other.getValue ()->getKind () < getValue ()->getKind ())
    return false;
  return *getValue () < *other.getValue ();
}

#ifndef EXPR_CACHE
class Value*
Constant::do_eval (const class Valuation* valuation) const
{
  return myValue->copy ();
}
#endif // EXPR_CACHE

#ifdef DEBUG

void
Constant::prettyPrint (unsigned indent) const
{
  myValue->prettyPrint (indent);
}

#endif // DEBUG
