// Dynamic place contents -*- c++ -*-

#include "PlaceContents.h"
#include <cassert>
#include "Place.h"
#include "GlobalMarking.h"
#include "Valuation.h"

PlaceContents::PlaceContents (const class Place* place) :
  myIndex (place->getIndex ())
{
  assert (place && place->getType ());
  setType (place->getType ());
}

PlaceContents::~PlaceContents ()
{
}

class PlaceMarking*
PlaceContents::meval (const class Valuation& valuation) const
{
  return new class PlaceMarking ((*valuation.getGlobalMarking ())[myIndex]);
}

#ifdef DEBUG
# include "util.h"

void
PlaceContents::prettyPrint (unsigned indent) const
{
  print (indent, "place %u\n", myIndex);
}

#endif // DEBUG
