// Maria temporal quantifier class -*- c++ -*-

#include "TemporalQuantifier.h"
#include "BoolType.h"
#include "Net.h"

TemporalQuantifier::TemporalQuantifier (enum Quantifier quantifier,
					class Expression* expr) :
  Expression (),
  myQuantifier (quantifier), myExpr (expr)
{
  assert (myExpr->getType ()->getKind () == Type::tBool);
  setType (Net::getBoolType ());
}

TemporalQuantifier::~TemporalQuantifier ()
{
  myExpr->destroy ();
}

const char*
TemporalQuantifier::getQuantifierString () const
{
  switch (getQuantifier ()) {
  case Always:
    return "always";
  case Exists:
    return "exists";
  }

  return "???";
}

#ifdef DEBUG
# include "util.h"

void
TemporalQuantifier::prettyPrint (unsigned indent) const
{
  print (indent, "%s(\n", getQuantifierString ());
  myExpr->prettyPrint (indent + 1);
  print (indent, ")\n");
}

#endif // DEBUG
