// Maria transition qualifier expression class -*- c++ -*-

#include "TransitionQualifier.h"
#include "Expression.h"
#include "Net.h"
#include "BoolType.h"

TransitionQualifier::TransitionQualifier (const class Transition* transition,
					  class Expression* expr) :
  Expression (),
  myTransition (transition), myExpr (expr)
{
  assert (!myExpr || myExpr->getType ()->getKind () == Type::tBool);
  setType (Net::getBoolType ());
}

TransitionQualifier::~TransitionQualifier ()
{
  myExpr->destroy ();
}

#ifdef DEBUG
# include "util.h"
# include "Transition.h"

void
TransitionQualifier::prettyPrint (unsigned indent) const
{
  print (indent, "[\n");
  print (indent + 1, "trans %s\n", myTransition->getName ());
  if (myExpr) {
    print (indent + 1, ":\n");
    myExpr->prettyPrint (indent + 1);
  }
  print (indent, "]\n");
}

#endif // DEBUG
