// undefined expression class -*- c++ -*-

#include "Undefined.h"

Undefined::Undefined (enum Fatalness fatalness) :
  Expression (),
  myFatalness (fatalness)
{
}

Undefined::~Undefined ()
{
}

class Value*
Undefined::do_eval (const class Valuation* valuation) const
{
  if (valuation) {
    switch (myFatalness) {
    case fError:
      valuation->flagUndefinedExpression ();
      return 0;
    case fFatalError:
      valuation->flagFatalExpression ();
      return 0;
    }
    assert (false);
  }
  return 0;
}

#ifdef DEBUG
# include "util.h"

void
Undefined::prettyPrint (unsigned indent) const
{
  print (indent, "%s\n",
	 myFatalness == fFatalError ? "fatal" : "undefined");
}

#endif // DEBUG
