// Identifier type class -*- c++ -*-

#include "IdType.h"
#include "IdValue.h"
#include "Constraint.h"
#include "Range.h"

IdType::IdType (card_t size) :
  Type (),
  mySize (size)
{
}

IdType::IdType (const IdType& old) :
  Type (),
  mySize (old.mySize)
{
}

IdType::~IdType ()
{
}

class Value*
IdType::getFirstValue () const
{
  return new class IdValue (this, 0);
}

class Value*
IdType::getLastValue () const
{
  return new class IdValue (this, mySize - 1);
}

card_t
IdType::do_getNumValues () const
{
  return mySize;
}

card_t
IdType::convert (const class Value* value) const
{
  assert (value && value->getKind () == Value::vId);
  return static_cast<const class IdValue*>(value)->getValue ();
}

class Value*
IdType::convert (card_t number) const
{
  return new class IdValue (this, number);
}
