// Identifier value class -*- c++ -*-

#include "IdValue.h"
#include "IdType.h"

IdValue::IdValue (const class Type* type, card_t value) :
  Value (type),
  myValue (value)
{
  assert (getType ()->getKind () == Type::tId);
  assert (myValue < static_cast<const class IdType*>(getType ())->getSize ());
}

IdValue::IdValue (const class IdValue& old) :
  Value (old.getType ()),
  myValue (old.getValue ())
{
  assert (getType ()->getKind () == Type::tId);
  assert (myValue < static_cast<const class IdType*>(getType ())->getSize ());
}

IdValue::~IdValue ()
{
}

void
IdValue::bottom ()
{
  myValue = 0;
}

void
IdValue::top ()
{
  myValue = static_cast<const class IdType*>(getType ())->getSize () - 1;
  assert (false);
}

bool
IdValue::increment ()
{
  if (++myValue == static_cast<const class IdType*>(getType ())->getSize ()) {
    myValue = 0;
    return false;
  }
  return true;
}

bool
IdValue::decrement ()
{
  if (!myValue) {
    myValue = static_cast<const class IdType*>(getType ())->getSize () - 1;
    return false;
  }
  else {
    myValue--;
    return true;
  }
}

class Value*
IdValue::cast (const class Type& type)
{
  assert (false);
  return NULL;
}

#include "Printer.h"

void
IdValue::display (const class Printer& printer) const
{
  printer.print (myValue);
}

#ifdef DEBUG
# include "util.h"

void
IdValue::prettyPrint (unsigned indent) const
{
  print (indent, "%u\n", myValue);
}

#endif // DEBUG
