// Value list class -*- c++ -*-

#include "ValueList.h"
#include "Value.h"

#include <cstring>

ValueList::ValueList (card_t size) :
  mySize (size), myComponents (NULL)
{
  if (mySize) {
    myComponents = new class Value*[mySize];
    memset (myComponents, 0, mySize * sizeof *myComponents);
  }
}

ValueList::ValueList (const class ValueList& old) :
  mySize (old.mySize), myComponents (NULL)
{
  if (mySize) {
    myComponents = new class Value*[mySize];
    for (card_t i = 0; i < mySize; i++)
      myComponents[i] =
	old.myComponents[i] ? old.myComponents[i]->copy () : NULL;
  }
}

ValueList::~ValueList ()
{
  for (card_t i = 0; i < mySize; i++)
    delete myComponents[i];

  delete[] myComponents;
}
