/** List of names -*- c++ -*- */

#ifndef NAMELIST_H_
# define NAMELIST_H_

# include <list>

/** List of names */
class NameList {
public:
  typedef std::list<char*> List;
  typedef List::iterator iterator;
  typedef List::const_iterator const_iterator;

  /** Constructor */
  NameList () : myList () {}
private:
  /** Copy constructor */
  NameList (const class NameList& old);
  /** Assignment operator */
  class NameList& operator= (const class NameList& old);
public:
  /** Destructor */
  ~NameList () {
    for (const_iterator i = begin (); i != end (); i++)
      delete *i;
  }

  /** Append a name to the list
   * @param name	name to be appended
   */
  void append (char* name) { myList.push_back (name); }

  bool empty () const { return myList.empty (); }
  size_t size () const { return myList.size (); }
  iterator begin () { return myList.begin (); }
  iterator end () { return myList.end (); }
  const_iterator begin () const { return myList.begin (); }
  const_iterator end () const { return myList.end (); }

private:
  /** The list */
  List myList;
};

#endif // NAMELIST_H_
