// Extendible reusable string buffer -*- c++ -*-

#include "StringBuffer.h"
#include <cstring>

StringBuffer::StringBuffer () :
  myString (new char[1]), myLength (0), myMaxLength (0)
{
  *myString = 0;
}

StringBuffer::StringBuffer (const class StringBuffer& old) :
  myString (new char[old.myLength + 1]),
  myLength (old.myLength), myMaxLength (old.myLength)
{
  memcpy (myString, old.myString, myLength + 1);
}

class StringBuffer&
StringBuffer::operator= (const class StringBuffer& old)
{
  memcpy (create (old.myLength), old.myString, old.myLength + 1);
  return *this;
}

StringBuffer::~StringBuffer ()
{
  delete[] myString;
}

class StringBuffer&
StringBuffer::operator= (const char* string)
{
  size_t length = strlen (string);
  memcpy (create (length), string, length + 1);
  return *this;
}

char*
StringBuffer::create (unsigned length)
{
  if (length > myMaxLength) {
    delete[] myString;
    myString = new char[length + 1];
    myMaxLength = length;
  }

  myLength = length;
  *myString = 0;

  return myString;
}

char*
StringBuffer::extend (unsigned length)
{
  if (myLength + length > myMaxLength) {
    char*s = new char[myLength + length + 1];
    // The buffer might contain embedded NULL chars,
    // therefore memcpy () instead of strcpy ().
    memcpy (s, myString, myLength + 1);
    s[myLength] = 0; // just in case
    delete[] myString;
    myString = s;
  }

  myLength += length;

  return myString;
}
